#
# spec file for package git (Version 1.5.2.4)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl asciidoc attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison brp-check-internal bzip2 coreutils cpio cpp cpp41 cracklib curl curl-devel cvs cyrus-sasl db diffutils docbook-xsl-stylesheets docbook_4 e2fsprogs file filesystem fillup findutils flex gawk gcc gcc41 gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd latex-ucs less libacl libattr libcom_err libgcc41 libgcrypt libgpg-error libidn libidn-devel libltdl libmudflap41 libnscd libpng libstdc++41 libtool libvolume_id libxcrypt libxml2 libxslt libzio linux-kernel-headers m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl openssl-devel pam pam-modules passivetex patch perl permissions popt post-build-checks procinfo procps psmisc pwdutils python rcs readline rpm sed sgml-skel sqlite strace sysvinit tar tcpd te_latex tetex texinfo timezone unzip util-linux vim xmltex xmlto xorg-x11-libICE xorg-x11-libSM xorg-x11-libX11 xorg-x11-libXau xorg-x11-libXdmcp xorg-x11-libXext xorg-x11-libXmu xorg-x11-libXp xorg-x11-libXpm xorg-x11-libXt zlib zlib-devel


Name:           git
BuildRequires:  asciidoc curl-devel sgml-skel xmlto
Version:        1.5.2.4
Release:        26.1
Summary:        git - a source code management tool
License:        GPL v2 or later
Group:          Development/Tools/Version Control
Url:            http://www.kernel.org/pub/software/scm/git/
Source0:        git-%{version}.tar.bz2
Patch1:         nov415345-1.diff
Patch2:         nov415345-2.diff
Patch3:         nov415345-3.diff
Patch4:         hack-strbuf-for-old-git.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Requires:       git-core, git-svn, git-cvs, git-arch, git-email, gitk

%description
This is an extremely fast directory content manager. It is intended to
be the base of an efficient, distributed source code management system.
This package includes rudimentary tools that can be used as a SCM, but
you should look elsewhere for tools for ordinary humans layered on top
of this.

This package will provide you with the complete core Git development
environment, bringing in all the subpackages.



Authors:
--------
    Linus Torvalds <torvalds@osdl.org>

%debug_package
%package core
License:        GPL v2 or later
Summary:        git-core--a Source Code Management Tool
Group:          Development/Tools/Version Control
Requires:       rsync, curl, less, openssh

%description core
This is an extremely fast directory content manager. It is intended to
be the base of an efficient, distributed source code management system.
This package includes rudimentary tools that can be used as a SCM, but
you should look elsewhere for tools for ordinary humans layered on top
of this.



Authors:
--------
    Linus Torvalds <torvalds@osdl.org>
    Junio C Hamano <junkio@cox.net>

%package svn
License:        GPL v2 or later
Summary:        git-svn - Git tools for importing Subversion repositories
Group:          Development/Tools/Version Control
Requires:       git-core = %{version}-%{release}, subversion
Requires:       subversion-perl

%description svn
Tools for importing Subversion repositories to the Git version control
system.



Authors:
--------
    Linus Torvalds <torvalds@osdl.org>
    Junio C Hamano <junkio@cox.net>

%package cvs
License:        GPL v2 or later
Summary:        git-cvs - Git tools for importing CVS repositories
Group:          Development/Tools/Version Control
Requires:       git-core = %{version}-%{release}, cvs, cvsps

%description cvs
Tools for importing CVS repositories to the Git version control system.



Authors:
--------
    Linus Torvalds <torvalds@osdl.org>
    Junio C Hamano <junkio@cox.net>

%package arch
License:        GPL v2 or later
Summary:        git-arch - Git tools for importing Arch repositories
Group:          Development/Tools/Version Control
Requires:       git-core = %{version}-%{release}, tla

%description arch
Tools for importing GNU Arch repositories to the GIT version control
system.



Authors:
--------
    Linus Torvalds <torvalds@osdl.org>
    Junio C Hamano <junkio@cox.net>

%package email
License:        GPL v2 or later
Summary:        git-email - Git tools for sending email
Group:          Development/Tools/Version Control
Requires:       git-core = %{version}-%{release} 

%description email
Email interface for the GIT version control system.



Authors:
--------
    Linus Torvalds <torvalds@osdl.org>
    Junio C Hamano <junkio@cox.net>

%package -n gitk
License:        GPL v2 or later
Summary:        gitk - Git revision tree visualiser
Group:          Development/Tools/Version Control
Requires:       git-core = %{version}-%{release}, tk >= 8.4

%description -n gitk
Tool for visualization of revision trees of projects maintained in the
Git version control system.



Authors:
--------
    Linus Torvalds <torvalds@osdl.org>
    Junio C Hamano <junkio@cox.net>

%prep
%setup
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%build
make %{_smp_mflags} CFLAGS="$RPM_OPT_FLAGS" \
       GITWEB_CONFIG="/etc/gitweb.conf" \
       GITWEB_PROJECTROOT="/srv/git" \
       WITH_OWN_SUBPROCESS_PY=YesPlease NO_EXPAT=1 \
       prefix=%{_prefix} mandir=%{_mandir} \
       all %{!?without_docs: doc} %{?jobs:-j %jobs}

%install
rm -rf $RPM_BUILD_ROOT
make %{_smp_mflags} CFLAGS="$RPM_OPT_FLAGS" DESTDIR=$RPM_BUILD_ROOT WITH_OWN_SUBPROCESS_PY=YesPlease NO_EXPAT=1 \
     prefix=%{_prefix} mandir=%{_mandir} \
     install %{!?_without_docs: install-doc}
install -d ${RPM_BUILD_ROOT}/srv/git
install -d ${RPM_BUILD_ROOT}/srv/www/cgi-bin
cp gitweb/gitweb.cgi $RPM_BUILD_ROOT/srv/www/cgi-bin/gitweb.cgi
(find $RPM_BUILD_ROOT%{_bindir} -type f | grep -vE "archimport|svn|cvs|email|gitk" | sed -e s@^$RPM_BUILD_ROOT@@)               > bin-man-doc-files
%if %{!?_without_docs:1}0
(find $RPM_BUILD_ROOT%{_mandir} $RPM_BUILD_ROOT/Documentation -type f | grep -vE "archimport|svn|git-cvs|email|gitk" | sed -e s@^$RPM_BUILD_ROOT@@ -e 's/$/*/' ) >> bin-man-doc-files
%endif
( pushd perl
  perl Makefile.PL
  make -f perl.mak DESTDIR=${RPM_BUILD_ROOT}  install_vendor
)
rm -rf ${RPM_BUILD_ROOT}/usr/lib/perl5/site_perl
%perl_process_packlist
find $RPM_BUILD_ROOT/%_mandir -type f -print0 | xargs -0 chmod 644

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README

%files svn
%defattr(-,root,root)
%{_bindir}/*svn*
%doc Documentation/*svn*.txt
%{!?_without_docs: %{_mandir}/man1/*svn*.1*}
%{!?_without_docs: %doc Documentation/*svn*.html }

%files cvs
%defattr(-,root,root)
%doc Documentation/*git-cvs*.txt
%{_bindir}/*cvs*
%{!?_without_docs: %{_mandir}/man1/*cvs*.1*}
%{!?_without_docs: %doc Documentation/*git-cvs*.html }

%files arch
%defattr(-,root,root)
%doc Documentation/git-archimport.txt
%{_bindir}/git-archimport
%{!?_without_docs: %{_mandir}/man1/git-archimport.1*}
%{!?_without_docs: %doc Documentation/git-archimport.html }

%files email
%defattr(-,root,root)
%doc Documentation/*email*.txt
%{_bindir}/*email*
%{!?_without_docs: %{_mandir}/man1/*email*.1*}
%{!?_without_docs: %doc Documentation/*email*.html }

%files -n gitk
%defattr(-,root,root)
%doc Documentation/*gitk*.txt
%{_bindir}/*gitk*
%{!?_without_docs: %{_mandir}/man1/*gitk*.1*}
%{!?_without_docs: %doc Documentation/*gitk*.html }

%files core -f bin-man-doc-files
%defattr(-,root,root)
%{_datadir}/git-core/
/srv/git/
/srv/www/cgi-bin/gitweb.cgi
%doc README COPYING Documentation/*.txt
%{!?_without_docs: %doc Documentation/*.html }
/var/adm/perl-modules/%{name}
%{perl_vendorlib}/Error.pm
%{perl_vendorlib}/Git.pm
%{perl_vendorarch}/auto/Git/
/usr/share/git-gui

%changelog
* Fri Aug 08 2008 - matz@suse.de
- Fix buffer overflows in several tools with repositories containing
  pathnames longer than PATH_MAX.  [bnc #415345]
* Tue Aug 07 2007 - dmueller@suse.de
- update to 1.5.2.4:
  * "git checkout" failed to switch back and forth between
  branches, one of which has "frotz -> xyzzy" symlink and
  file "xyzzy/filfre", while the other one has a file
  "frotz/filfre".
  * "git prune" used to segfault upon seeing a commit that is
  referred to by a tree object (aka "subproject").
  * "git diff --name-status --no-index" mishandled an added file.
  * "git apply --reverse --whitespace=warn" still complained
  about whitespaces that a forward application would have
  introduced.
* Thu Jul 05 2007 - dmueller@suse.de
- Update to 1.5.2.3:
  * fix many segfaults with the SVN gateway
  * various bugfixes
* Fri May 18 2007 - dmueller@suse.de
- Update to 1.5.1.4:
  * GIT <-> SVN gateway
  * New porcelain, much improved index handling
  * git-config
  * Bare repositories refuse commands that need a working tree
  * packed ref support
  * 3-way merges can be done without rcs
  * python dependency dropped
* Sat Nov 18 2006 - pbaudis@suse.cz
- Fix build failure from previous change (trivial omission)
* Fri Nov 17 2006 - pbaudis@suse.cz
- Fix git-arch package containing git-archive and git-upload-archive
  [#222074]
* Fri Nov 17 2006 - pbaudis@suse.cz
- Upgrade to git-1.4.3.4 - only few bugfixes, most importantly
  git-apply wouldn't apply creation/deletion patches
* Tue Nov 07 2006 - ro@suse.de
- fix permissions for manpages
* Sun Oct 29 2006 - meissner@suse.de
- use RPM_OPT_FLAGS also in %%install make
* Thu Oct 26 2006 - pbaudis@suse.cz
- Upgrade to git-1.4.3.3 - bugfixes release
* Thu Oct 19 2006 - pbaudis@suse.cz
- Update to git-1.4.3 - UI improvements, speedups, random new
  features (e.g. git-daemon name-based virtual hosting support),
  basic Git.pm
- Fixes build failures due to asciidoc incompatibilities
* Tue Jul 25 2006 - pbaudis@suse.cz
- Update to git-1.4.1.1 - includes gitweb, many bugfixes, some
  commands are converted from shell to C, aliasing support,
  documentation improvements and so on.
- Junio's patch got applied upstream.
- Pre-create /srv/git for bare Git repositories hosting.
- Install gitweb to /srv/www/cgi-bin pre-configured to look
  for packages at /srv/git.
* Mon May 15 2006 - pbaudis@suse.cz
- Update to git-core-1.3.1 - git-cvsserver pserver interface,
  .git/refs/remotes branches support, blame/annotate tools,
  builtin diff, faster and better rename detection and number
  of other stuff.
- Add Junio's patch for saner handling of symlink refs. This is
  an important bugfix since without this, it is impossible to
  bisect behind kernel linux-v2.6.15-g117a93d.
- Olaf Hering's cutnpaste patch got applied upstream.
* Mon Mar 13 2006 - ro@suse.de
- change requires from "openssh-clients" to "openssh"
  (former does not exist)
* Fri Mar 10 2006 - pbaudis@suse.cz
- Add Olaf Hering's patch for easier cut'n'pasting.
* Wed Mar 08 2006 - pbaudis@suse.cz
- Update to git-core 1.2.4.
- This is a security fix: there was a buffer overflow when checking
  out a tree with an insanely long symlink. (No Bugzilla id.)
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Jan 17 2006 - pbaudis@suse.cz
- Fix the specfile build (no expat and asciidoc, xmlto problems)
* Tue Jan 17 2006 - pbaudis@suse.cz
- Update to git-core 1.1.3.
- Modify the specfile so that it looks more like the stock one.
- Split bits to subpackages
* Sun Dec 04 2005 - schwab@suse.de
- Fix embedded paths.
* Thu Oct 06 2005 - schwab@suse.de
- Don't build documentation in parallel.
* Mon Sep 19 2005 - schwab@suse.de
- Update to git-core 0.99.7.
- Install manpages.
* Fri Aug 05 2005 - kasievers@suse.de
- New version 0.99.3git20050905
  rename git to git-core, to match the upstream package name
* Sun Jul 03 2005 - kasievers@suse.de
- New version 0.7git20050703
* Fri Jul 01 2005 - kasievers@suse.de
- New version 20050630
* Fri Jun 24 2005 - kasievers@suse.de
- New version 20050624
* Sun Jun 12 2005 - kay.sievers@suse.de
- New version 20050612
* Thu Jun 02 2005 - kay.sievers@suse.de
- Split git/Cogito into separate packages
- Update git to version 20050602
* Fri May 20 2005 - schwab@suse.de
- Use RPM_OPT_FLAGS.
- Specfile cleanup.
* Fri May 20 2005 - mmj@suse.de
- %%_libdir -> FHS libexec
* Fri May 20 2005 - skh@suse.de
- initial package
